;************************************************************************************************************
; AutoWinSize
;
; 21.03.2006 Peter Hahlganss
;************************************************************************************************************
; Switches
#Persistent
#SingleInstance force
SetKeyDelay, 50

;************************************************************************************************************
; Config:
AppName = AutoWinSize
Version = 0.9 beta

;************************************************************************************************************
; !!!!!!!!!!! do not delete the following comments !!!!!!!!!!!!!!
; the following lines are only defined for AhkStart.exe. Do not change names and do not insert variables here:
; this is only evaluated during the compile process:
;AppIcon = Icons\AutoWinSize.ico
;AHK_Icon3 = Icons\AutoWinSizeOn.ico
;AHK_Icon4 = Icons\AutoWinSizeOff.ico
;AHK_Icon5 = Icons\AutoWinSizeOnHidden.ico
;AHK_Icon6 = Icons\AutoWinSizeOffHidden.ico
;************************************************************************************************************

; file containing definition of tagged windows
TagFileName = %A_ScriptDir%\%AppName%-%A_ComputerName%-%A_UserName%.dat
OnIconNumber        = 3  ; number of icon added to AutoHotkeySC.bin
OffIconNumber       = 4  ; number of icon added to AutoHotkeySC.bin
OnHiddenIconNumber  = 5  ; number of icon added to AutoHotkeySC.bin
OffHiddenIconNumber = 6  ; number of icon added to AutoHotkeySC.bin
; Registry path
RegPath = Software\AutoWinSize

;************************************************************************************************************
; Icon and Window appearance:
Menu, Tray, Icon, %A_ScriptFullPath%, %OnIconNumber%  ; Icon of AutoHotkeySC.bin
I_TrayToolTip = %AppName% %Version%                   ; Text for tool tray tip
Menu, Tray, Tip, %I_TrayToolTip%

;************************************************************************************************************
; include the readme and the change log file in the compiled script:
FileInstall, AutoWinSize_ChangeLog.txt, AutoWinSize_ChangeLog.txt, 1
FileInstall, AutoWinSize_Help.txt, AutoWinSize_Help.txt, 1

; Default values for options if not otherwise defined in the registry
ApplyIntervalDef = 1000 ; ms
ShowTrayIconDef  = 1
MainWinKeyDef    = ^F10
OnTopKeyDef      = ^F1
NotOnTopKeyDef   = ^F2
HideWindowKeyDef = #h

;************************************************************************************************************
; Main Window dimensions
MainGUItitle = %AppName% %Version%
MainGUIdimensions = xCenter yCenter h372 w473

; Edit Tag Window dimensions
EditTagGUItitle = %AppName% - Edit Tag
EditTagGUIdimensions = xCenter yCenter h492 w374

; Options Window dimensions
OptionsGUItitle = %AppName% - Options
OptionsGUIdimensions = xCenter yCenter h358 w259

;************************************************************************************************************
; The following list contains the classes for dialogs (will be ignored)
DialogClassMatchList = #32770,bosa_sdm,bosa_sdm_Mso96,SunAwtDialog

;************************************************************************************************************
; Initial value for the AutoWinSize disable function should be 0 (= not disabled)
AutoWinSizeDisabled = 0

;************************************************************************************************************
; Definition of TitleMatchMode Listbox contents
TagTitleMatchMode1 = exact match
TagTitleMatchMode2 = starts with
TagTitleMatchMode3 = anywhere
TagTitleMatchMode4 = RegExp
TagTitleMatchMode  = %TagTitleMatchMode1%|%TagTitleMatchMode2%|%TagTitleMatchMode3%|%TagTitleMatchMode4%
TitleMatch1Selected = |%TagTitleMatchMode1%||%TagTitleMatchMode2%|%TagTitleMatchMode3%|%TagTitleMatchMode4%
TitleMatch2Selected = |%TagTitleMatchMode1%|%TagTitleMatchMode2%||%TagTitleMatchMode3%|%TagTitleMatchMode4%
TitleMatch3Selected = |%TagTitleMatchMode1%|%TagTitleMatchMode2%|%TagTitleMatchMode3%||%TagTitleMatchMode4%
TitleMatch4Selected = |%TagTitleMatchMode1%|%TagTitleMatchMode2%|%TagTitleMatchMode3%|%TagTitleMatchMode4%||

; Definition of View Listbox contents
TagViewOptions1 = Large Icons
TagViewOptions2 = Small Icons
TagViewOptions3 = List
TagViewOptions4 = Details
TagViewOptionsList   = %TagViewOptions1%|%TagViewOptions2%|%TagViewOptions3%|%TagViewOptions4%
ViewOptions1Selected = |%TagViewOptions1%||%TagViewOptions2%|%TagViewOptions3%|%TagViewOptions4%
ViewOptions2Selected = |%TagViewOptions1%|%TagViewOptions2%||%TagViewOptions3%|%TagViewOptions4%
ViewOptions3Selected = |%TagViewOptions1%|%TagViewOptions2%|%TagViewOptions3%||%TagViewOptions4%
ViewOptions4Selected = |%TagViewOptions1%|%TagViewOptions2%|%TagViewOptions3%|%TagViewOptions4%||

; Definition of Action Listbox contents
TagActionOption1 = None
TagActionOption2 = Minimize
TagActionOption3 = Maximize
TagActionOption4 = Restore
TagActionOption5 = Hide
TagActionOption6 = Close
TagActionOptionList = |%TagActionOption1%|%TagActionOption2%|%TagActionOption3%|%TagActionOption4%|%TagActionOption5%|%TagActionOption6%
ActionOption1Selected = |%TagActionOption1%||%TagActionOption2%|%TagActionOption3%|%TagActionOption4%|%TagActionOption5%|%TagActionOption6%
ActionOption2Selected = |%TagActionOption1%|%TagActionOption2%||%TagActionOption3%|%TagActionOption4%|%TagActionOption5%|%TagActionOption6%
ActionOption3Selected = |%TagActionOption1%|%TagActionOption2%|%TagActionOption3%||%TagActionOption4%|%TagActionOption5%|%TagActionOption6%
ActionOption4Selected = |%TagActionOption1%|%TagActionOption2%|%TagActionOption3%|%TagActionOption4%||%TagActionOption5%|%TagActionOption6%
ActionOption5Selected = |%TagActionOption1%|%TagActionOption2%|%TagActionOption3%|%TagActionOption4%|%TagActionOption5%||%TagActionOption6%
ActionOption6Selected = |%TagActionOption1%|%TagActionOption2%|%TagActionOption3%|%TagActionOption4%|%TagActionOption5%|%TagActionOption6%||

;********************************************************************************************************
; Functions for hidden windows handling:
;********************************************************************************************************
AddHiddenWin(HideID)
	{
	global

	CheckHiddenWins()

	HiddenWinIDs =
	RegRead, HiddenWinIDs, HKEY_CURRENT_USER, %RegPath%\HiddenWins, WinIDs

	IfNotInString, HiddenWinIDs, %HideID%
		{
		HiddenWinIDs = %HiddenWinIDs%%HideID%|
		RegWrite, REG_SZ, HKEY_CURRENT_USER, %RegPath%\HiddenWins, WinIDs, %HiddenWinIDs%
		}

	; update the tray menu
	CreateTrayMenu()

	Return
	}

CheckHiddenWins()
	{
	global
	local HiddenWinIDsNew, oldTitleMatchMode, result, Style
	
	RegRead, HiddenWinIDs, HKEY_CURRENT_USER, %RegPath%\HiddenWins, WinIDs
	If HiddenWinIDs =
		Return

	DetectHiddenWindows, On
	oldTitleMatchMode = %A_TitleMatchMode%
	SetTitleMatchMode, 3
	HiddenWinIDsNew =
	Loop, Parse, HiddenWinIDs,|,
		{
		IfWinExist, ahk_id %A_LoopField%
			{
			; only add to menu if window is hidden
			If IsWindowHidden(A_LoopField)
  				HiddenWinIDsNew = %HiddenWinIDsNew%%A_LoopField%|
			}
		}
	SetTitleMatchMode, %oldTitleMatchMode%
	DetectHiddenWindows, Off
	
	HiddenWinIDs = %HiddenWinIDsNew%
	RegWrite, REG_SZ, HKEY_CURRENT_USER, %RegPath%\HiddenWins, WinIDs, %HiddenWinIDs%

	; update the tray menu
	CreateTrayMenu()

	Return
	}

UnhideAllWindows()
	{
	global
	
	RegRead, HiddenWinIDs, HKEY_CURRENT_USER, %RegPath%\HiddenWins, WinIDs
	If HiddenWinIDs =
		Return

	DetectHiddenWindows, On
	oldTitleMatchMode = %A_TitleMatchMode%
	SetTitleMatchMode, 3
	Loop, Parse, HiddenWinIDs,|,
		{
		IfWinExist, ahk_id %A_LoopField%
			{
			; only add to menu if window is hidden
			If IsWindowHidden(A_LoopField)
  				WinShow, ahk_id %A_LoopField%
			}
		}
	SetTitleMatchMode, %oldTitleMatchMode%
	DetectHiddenWindows, Off
	
	; update the tray menu
	CreateTrayMenu()

	Return
	}

IsWindowHidden(WinID)  ; Returns True if the windows is hidden
	{
	WinGet, Style, Style, ahk_id %WinID%
	result := Style & 0x10000000  ; 0x10000000 is WS_VISIBLE
	If result = 0
		Return True
	Else
		Return False
	}

;************************************************************************************************************
; Modify Tray Menu:
;************************************************************************************************************
CreateTrayMenu()
	{
	global
	local title

	; delete tray menu
	Menu, Tray, DeleteAll
	; delete sub menu (first create dummy entry to be able to delete it)
	Menu, HiddenWinsMenu, Add, dummy, HiddenWinsMenuClick
	Menu, HiddenWinsMenu, DeleteAll

	Menu, Tray, Click, 1
	Menu, Tray, NoStandard
	Menu, Tray, Add, Show Dialog..., ShowDialogClick
	Menu, Tray, Default, Show Dialog...
	Menu, Tray, Add, Disable AutoWinSize, TraySingleClick
	Menu, Tray, Add, Options..., ShowOptionsBox
	Menu, Tray, Add
	
	; Create Submenu with hidden windows
	RegRead, HiddenWinIDs, HKEY_CURRENT_USER, %RegPath%\HiddenWins, WinIDs
	ExistHiddenWindows = 0
	If HiddenWinIDs <>
		{
		DetectHiddenWindows, On
		Loop, Parse, HiddenWinIDs,|,
			{
			IfWinExist, ahk_id %A_LoopField%
				{
				WinGetTitle, title, ahk_id %A_LoopField%
				Menu, HiddenWinsMenu, Add, %title%, HiddenWinsMenuClick
				ExistHiddenWindows = 1
				}
			}
		DetectHiddenWindows, Off

		Menu, Tray, Add, Hidden Windows, :HiddenWinsMenu
		Menu, Tray, Add
		}
		
	Menu, Tray, Add, About..., ShowAboutBox
	Menu, Tray, Add, Exit, AppExit
	
	Gosub, SetTrayIcon
	}

;************************************************************************************************************
; HideWindow (hides a window and adds it to the context menu):
;************************************************************************************************************
HideWindow(WinID)
	{
	WinHide, ahk_id %WinID%
	AddHiddenWin(WinID)
	}

;********************************************************************************************************
; Function PWinSize for window size and position handling:
;********************************************************************************************************
PWinSize(WinTitle, PosX, PosY, Width, Height)
	{
	global
	local temp, WinCount, WinID

	WinGet, WinCount, List, %WinTitle% ; set WinCount to the number of matching windows; WinCount%n% contains the IDs
;	text =%WinCount% / %WinCountIn% - '%WinTitle%' - %PosX% - %PosY% - %Width% - %Height%

	If WinCount > 0  ; window matching the title was found
		{
		If WinCount > %WinCountIn%  ; there are more matching windows than the last time
			{
			; prepare a list for "If...not in..." command below
			WinCountInList =
			Loop, %WinCountIn%
				{
				StringTrimRight, temp, WinCountIn%a_index%, 0
				WinCountInList = %WinCountInList%,%temp%
				}

			; search window that is not in the list
			Loop, %WinCount%
				{
				StringTrimRight, WinID, WinCount%a_index%, 0
				WinGetClass, this_class, ahk_id %WinID%

				If WinID not in %WinCountInList%  ; new matching window found
					{
					if(PosX <> -32000) & (PosY <> -32000)  ; window is not minimized
						{		
						If TagIgnoreDialogs = 1
							{
							;msgbox, ignore dialog active`nid=%WinID%`nclass=%this_class%
							If this_class contains %DialogClassMatchList%
								{
								;msgbox, dialog ignored`nid=%WinID%`nclass=%this_class%
								Continue
								}
							}

						StringTrimRight, WinID, WinCount%a_index%, 0
						
	;					msgbox, '%WinTitle%' - '%WinID%' - %PosX% - %PosY% - %Width% - %Height%`n%WinCountInList%
						If PosX < 0
							PosX =
						If PosY < 0
							PosY =
						If Width < 0
							{
							If Width < -1
								{
								; limit window width to "Width"
								Width := -Width
								WinGetPos,,, ActWidth,, ahk_id %WinID%  ; get actual width
								If ActWidth < %Width%
									Width =
								}
							Else
								Width =
							}
						If Height < 0
							{
							If Height < -1
								{
								; limit window height to "Height"
								Height := -Height
								WinGetPos,,,, ActHeight, ahk_id %WinID%  ; get actual height
								If ActHeight < %Height%
									Height =
								}
							Else
								Height =
							}
	;					text = %text%`nWinCountInList = %WinCountInList%
	;					text = %text%`nWinTitle='%WinTitle%' - WinID='%WinID%' - %PosX% - %PosY% - %Width% - %Height%

						WinMove, ahk_id %WinID%,, %PosX%, %PosY%, %Width%, %Height% ; move window with WinID

						If this_class contains ExploreWClass,CabinetWClass
							{
							;msgbox, ahk_id %WinID% - %WinTitle% - %TagView%
							If TagView = %TagViewOptions1%  ; Large Icons
								SendMessage, 0x111, 28713, 0,, ahk_id %WinID%
							If TagView = %TagViewOptions2%  ; Small Icons
								SendMessage, 0x111, 28714, 0,, ahk_id %WinID%
							If TagView = %TagViewOptions3%  ; List
								SendMessage, 0x111, 28715, 0,, ahk_id %WinID%
							If TagView = %TagViewOptions4%  ; Details
								SendMessage, 0x111, 28716, 0,, ahk_id %WinID%
							}

						;If TagAction = %TagActionOption1% ; None
						If TagAction = %TagActionOption2% ; Minimize
							WinMinimize, ahk_id %WinID%
						Else
						If TagAction = %TagActionOption3% ; Maximize
							WinMaximize, ahk_id %WinID%
						Else
						If TagAction = %TagActionOption4% ; Restore
							WinRestore, ahk_id %WinID%
						Else
						If TagAction = %TagActionOption5% ; Hide
							HideWindow(WinID)
						Else
						If TagAction = %TagActionOption6% ; Close
							WinClose, ahk_id %WinID%
							
						If TagCommand <>
							{
							StringReplace, TagCommand, TagCommand, `%WinID`%, %WinID%, All

							; split into Command and CommandText
							StringSplit, CommandParts, TagCommand, `,  ;, %A_Space%%A_Tab%
							; CommandText:
							CommandText = %CommandParts2%
							i := CommandParts0 - 2
							Loop, %i%
								{
								n := A_Index + 2
								x := CommandParts%n%
								CommandText = %CommandText%, %x%
								}
							; execute commands
							StringLower, CommandParts1, CommandParts1
							If CommandParts1 = run
								{
								;msgbox, Run, %CommandText%
								Run, %CommandText%,, UseErrorLevel
								If ErrorLevel = ERROR
									MsgBox, 4096, %AppName% - Run Command, Tag '%TagComment%':`nFailed to execute the following command:`n`n%CommandText%.
								}
							Else If CommandParts1 = send
								{
								Sleep, 100
								WinActivate, ahk_id %WinID%
								Send, %CommandText%
								}
							}
							
						}
					}
				}
;			msgbox, %text%
			}
		WinCountIn := WinCount ; copy WinCount to WinCountIn:
		Loop, %WinCount%
			WinCountIn%a_index% := WinCount%a_index%
		
		Return
		}
	Else
		{
		WinCountIn := WinCount ; copy WinCount to WinCountIn:
		Return  ; window does not exist anymore -> prepare movement for next time
		}
	}

;************************************************************************************************************
; This will visit all windows on the entire system and display info about each of them:
;************************************************************************************************************
RefreshWinList()
	{
	global
	
	n = 1
	WinList = |
	WinGet, id, list,,, Program Manager
	Loop, %id%
		{
		StringTrimRight, this_id, id%a_index%, 0
		WinGetClass, this_class, ahk_id %this_id%
		WinGetTitle, this_title, ahk_id %this_id%
		WinGetPos, X, Y, W, H, %this_title%

		if (this_class <> "Shell_TrayWnd")
			{
			WinGet, MinMaxState, MinMax, ahk_id %this_id%
			If MinMaxState <> -1  ; window is not minimized
				{
				WinListTitle%n% = %this_title%
				WinListComment%n% = %this_title%
				WinListID%n%    = %this_id%
				WinListClass%n% = %this_class%
				WinListCount%n% = 0
				WinListMatchMode%n% = %TagTitleMatchMode1%
				WinListCenterWin%n% = 0
				WinListApplyOnce%n% = 1
				WinListIgnoreDialogs%n% = 1
				WinListX%n% = %X%
				WinListY%n% = %Y%
				WinListW%n% = %W%
				WinListH%n% = %H%
				WinListApplyX%n% = 1
				WinListApplyY%n% = 1
				WinListApplyW%n% = 1
				WinListApplyH%n% = 1
				WinListToolBar%n% 		= 0
				WinListStatusBar%n% 	= 0
				WinListCommand%n% 	=
				WinListView%n% = %TagViewOptions4%
				WinListAction%n% = %TagActionOption1%

				;WinList = %WinList%%n% - %this_title% | 
				WinList = %WinList%%this_title% | 
				n += 1
				}
			}
		}
	GuiControl, , WinListGUI, %WinList%
	;msgbox, %WinList%
	}

;************************************************************************************************************
; Read the Tagfile
;************************************************************************************************************
ReadTagFile()
	{
	global
	
	n = 1
	TagList = |
	Loop
		{
		IniRead, TagComment, %TagFileName%, Tag%n%, Comment
		IniRead, TagTitle,   %TagFileName%, Tag%n%, Title

		if TagComment = ERROR            ; could not read TagComment
			{
			if TagTitle = ERROR          ; could not read TagTitle also -> end of ini file
				break
			else
				TagComment = %TagTitle%  ; only TagComment was not in ini file -> set TagComment = TagTitle
			}
			
		TagTitle%n%   := TagTitle
		TagComment%n% := TagComment

		IniRead, TagWinID%n%,     		%TagFileName%, Tag%n%, WinID, 			%A_Space%
		IniRead, TagWinClass%n%,  		%TagFileName%, Tag%n%, WinClass,		%A_Space%
		;TagWinCount%n% := 0
		IniRead, TagMatchMode%n%, 		%TagFileName%, Tag%n%, MatchMode, 		%TagTitleMatchMode1%
		IniRead, TagCenterWin%n%, 		%TagFileName%, Tag%n%, CenterWin, 		0
		IniRead, TagApplyOnce%n%, 		%TagFileName%, Tag%n%, ApplyOnce, 		1
		IniRead, TagIgnoreDialogs%n%, 	%TagFileName%, Tag%n%, IgnoreDialogs, 	1
		IniRead, TagX%n%,         		%TagFileName%, Tag%n%, X,				0
		IniRead, TagY%n%,         		%TagFileName%, Tag%n%, Y,				0
		IniRead, TagW%n%,         		%TagFileName%, Tag%n%, Width,			300
		IniRead, TagH%n%,         		%TagFileName%, Tag%n%, Height,			300
		IniRead, TagApplyX%n%,    		%TagFileName%, Tag%n%, ApplyX, 			1
		IniRead, TagApplyY%n%,    		%TagFileName%, Tag%n%, ApplyY, 			1
		IniRead, TagApplyW%n%,    		%TagFileName%, Tag%n%, ApplyWidth, 		1
		IniRead, TagApplyH%n%,    		%TagFileName%, Tag%n%, ApplyHeight, 	1
		IniRead, TagToolBar%n%,   		%TagFileName%, Tag%n%, ToolBar, 		0
		IniRead, TagStatusBar%n%, 		%TagFileName%, Tag%n%, StatusBar, 		0
		IniRead, TagCommand%n%,			%TagFileName%, Tag%n%, Command,			%A_Space%
		IniRead, TagView%n%,       		%TagFileName%, Tag%n%, View, 			%TagViewOptions4%
		IniRead, TagAction%n%,    		%TagFileName%, Tag%n%, Action, 			%TagActionOption1%

		;TagList = %TagList%%n% - %TagComment% | 
		TagList = %TagList%%TagComment% | 
		TagCount = %n%
		n++
		Sleep, 10
		}
	GuiControl, , TagListGUI, %TagList%
	;msgbox, %TagCount% - %TagList%
	}

;************************************************************************************************************
; Write the Tagfile
;************************************************************************************************************
WriteTagFile()
	{
	global

	FileDelete, %TagFileName% ; delete old file to reset the contents (file will be new created)

	Loop, %TagCount%
		{
		n = %a_index%

		Title 			:= TagTitle%n%
		Comment			:= TagComment%n%
		WinID 			:= TagWinID%n%
		WinClass 		:= TagWinClass%n%
		MatchMode 		:= TagMatchMode%n%
		CenterWin 		:= TagCenterWin%n%
		ApplyOnce 		:= TagApplyOnce%n%
		IgnoreDialogs 	:= TagIgnoreDialogs%n%
		X 				:= TagX%n%
		Y 				:= TagY%n%
		W 				:= TagW%n%
		H 				:= TagH%n%
		ApplyX 			:= TagApplyX%n%
		ApplyY 			:= TagApplyY%n%
		ApplyW 			:= TagApplyW%n%
		ApplyH 			:= TagApplyH%n%
		ToolBar 		:= TagToolBar%n%
		StatusBar 		:= TagStatusBar%n%
		Command   		:= TagCommand%n%
		View 	    	:= TagView%n%
		Action 			:= TagAction%n%

		buffer = [Tag%n%]`n
		buffer = %buffer%Title=%Title%`n
		buffer = %buffer%Comment=%Comment%`n
		buffer = %buffer%WinID=%WinID%`n
		buffer = %buffer%WinClass=%WinClass%`n
		buffer = %buffer%MatchMode=%MatchMode%`n
		buffer = %buffer%CenterWin=%CenterWin%`n
		buffer = %buffer%ApplyOnce=%ApplyOnce%`n
		buffer = %buffer%IgnoreDialogs=%IgnoreDialogs%`n
		buffer = %buffer%X=%X%`n
		buffer = %buffer%Y=%Y%`n
		buffer = %buffer%Width=%W%`n
		buffer = %buffer%Height=%H%`n
		buffer = %buffer%ApplyX=%ApplyX%`n
		buffer = %buffer%ApplyY=%ApplyY%`n
		buffer = %buffer%ApplyWidth=%ApplyW%`n
		buffer = %buffer%ApplyHeight=%ApplyH%`n
		buffer = %buffer%ToolBar=%ToolBar%`n
		buffer = %buffer%StatusBar=%StatusBar%`n
		buffer = %buffer%Command=%Command%`n
		buffer = %buffer%View=%View%`n
		buffer = %buffer%Action=%Action%`n
		FileAppend, %buffer%, %TagFileName%
		}
	ReadTagFile()
	}

;************************************************************************************************************
; Read the Options
;************************************************************************************************************
ReadOptions()
	{
	global

	; read registry key containing options
	RegRead, ApplyInterval, HKEY_CURRENT_USER, %RegPath%\Options, ApplyInterval
	RegRead, ShowTrayIcon,  HKEY_CURRENT_USER, %RegPath%\Options, ShowTrayIcon
	RegRead, MainWinKey,    HKEY_CURRENT_USER, %RegPath%\Options, MainWinKey
	RegRead, OnTopKey,      HKEY_CURRENT_USER, %RegPath%\Options, OnTopKey
	RegRead, NotOnTopKey,   HKEY_CURRENT_USER, %RegPath%\Options, NotOnTopKey
	RegRead, HideWindowKey, HKEY_CURRENT_USER, %RegPath%\Options, HideWindowKey
	If ApplyInterval =
		ApplyInterval = %ApplyIntervalDef%
	If ShowTrayIcon =
		ShowTrayIcon = %ShowTrayIconDef%
	If MainWinKey =
		MainWinKey = %MainWinKeyDef%
	If OnTopKey =
		OnTopKey = %OnTopKeyDef%
	If NotOnTopKey =
		NotOnTopKey = %NotOnTopKeyDef%
	If HideWindowKey =
		HideWindowKey = %HideWindowKeyDef%

	; check/limit setting for ApplyInterval
	CheckApplyInterval()

	; apply settings for tray icon
	If ShowTrayIcon
		Menu, Tray, Icon
	Else
		Menu, Tray, NoIcon

	; apply settings for hotkeys
	ApplyHotkeys()

	}	

;************************************************************************************************************
; Write the Options
;************************************************************************************************************
WriteOptions()
	{
	global

	; write values to registry key containing options
	RegWrite, REG_SZ, HKEY_CURRENT_USER, %RegPath%\Options, ApplyInterval, %ApplyInterval%
	RegWrite, REG_SZ, HKEY_CURRENT_USER, %RegPath%\Options, ShowTrayIcon,  %ShowTrayIcon%
	RegWrite, REG_SZ, HKEY_CURRENT_USER, %RegPath%\Options, MainWinKey,    %MainWinKey%
	RegWrite, REG_SZ, HKEY_CURRENT_USER, %RegPath%\Options, OnTopKey,      %OnTopKey%
	RegWrite, REG_SZ, HKEY_CURRENT_USER, %RegPath%\Options, NotOnTopKey,   %NotOnTopKey%
	RegWrite, REG_SZ, HKEY_CURRENT_USER, %RegPath%\Options, HideWindowKey, %HideWindowKey%
	}	

;************************************************************************************************************
CheckApplyInterval()
	{
	global

	If ApplyInterval < 250
		ApplyInterval = 250
	If ApplyInterval > 10000
		ApplyInterval = 10000
	}

;************************************************************************************************************
; Main GUI setup:
;************************************************************************************************************
CreateMainGUI()
	{
	global
	Gui, 1:Destroy
	Gui, 1:Add, Text,                                               		x7   y0   w185 h15,  Active Windows:
	Gui, 1:Add, Text,                                               		x280 y0   w185 h15,  Tagged Windows:
	Gui, 1:Add, ListBox, AltSubmit vWinListGUI gWinListProc Choose1 		x7   y15  w185 h325, %WinListBox%
	Gui, 1:Add, ListBox, AltSubmit vTagListGUI gTagListProc Choose1 		x280 y15  w185 h325, %TagListBox%

	Gui, 1:Add, Button, gTagWindow                                  		x200 y15  w72  h25, &Tag Window
	Gui, 1:Add, Button, gShowInfo                                   		x200 y45  w72  h25, Show &Info
	Gui, 1:Add, Button, gApplyTags                                   		x200 y170 w72  h25, A&pply Tags
	Gui, 1:Add, Button, gSaveTags                                   		x200 y200 w72  h25, &Save Tags
	Gui, 1:Add, Button, gRefreshWinList                             		x7   y340 w72  h25, &Refresh List

	Gui, 1:Add, Button, gRemoveTag                                  		x315 y340 w72  h25, Remo&ve Tag
	Gui, 1:Add, Button, gEditTag                                    		x393 y340 w72  h25, &Edit Tag

	Gui, 1:Add, Button, gShowOptionsBox 		                      		x200 y277 w72  h25, &Options...
	Gui, 1:Add, Button, gShowAboutBox 		                      			x200 y307 w72  h25, &About
	Gui, 1:Add, Button, gCloseDialog Default                        		x200 y340 w72  h25, &Close Dialog

	; +Owner must be used after the window's owner is created but before the owned is created 
	; (i.e. before commands such as "Gui Add").
	Gui, 2:+owner ; Make #2 window owned by script's main window.
	Gui, 3:+owner ; Make #2 window owned by script's main window.

	ReadTagFile()
	ReadOptions()
	Gui, 1:Show, %MainGUIdimensions%, %MainGUItitle%
	RefreshWinList()
	}

;************************************************************************************************************
; Edit Tag Dialog Box Setup:
;************************************************************************************************************
CreateEditTagGUI()
	{
	global
	Gui, 2:Destroy
	Gui, 2:-Maximize -Minimize +ToolWindow +AlwaysOnTop
	Gui, 2:Add, Text, 												x6   y10  w80  h20, Tag Comment:
	Gui, 2:Add, Edit, 		vEditTagComment							x86  y7   w270 h20
	Gui, 2:Add, Text, 												x6   y40  w80  h20, Title To Match:
	Gui, 2:Add, Edit, 		vEditTagTitle							x86  y37  w270 h20
	Gui, 2:Add, Text, 												x6   y70  w100 h20, Match Mode:
	Gui, 2:Add, DropDownList, vEditTagMatchMode						x86  y67  w110 h200, %TagTitleMatchMode%

	Gui, 2:Add, GroupBox, 											x16  y90  w340 h105, Actions:
	Gui, 2:Add, Checkbox, 	vEditTagCenterWin						x26  y102 w100 h30, Center Window
	Gui, 2:Add, Checkbox, 	vEditTagApplyOnce						x140 y102 w100 h30, Apply only once
	Gui, 2:Add, Checkbox, 	vEditTagIgnoreDialogs					x255 y102 w90  h30, Ignore Dialogs
	Gui, 2:Add, Text, 												x26  y135 w70  h20, State:
	Gui, 2:Add, DropDownList, vEditTagAction						x86  y132 w80  h200, %TagActionOptionList%
	Gui, 2:Add, Text, 												x26  y165 w70  h20, Command:
	Gui, 2:Add, Edit, 		vEditTagCommand							x86  y162 w255 h20

	Gui, 2:Add, GroupBox, 											x16  y202 w340 h147, Position:
	Gui, 2:Add, Text, 												x26  y224 w50  h20, X Position:
	Gui, 2:Add, Text, 												x26  y254 w50  h20, Y Position:
	Gui, 2:Add, Text, 												x26  y284 w50  h20, Width:
	Gui, 2:Add, Text, 												x26  y314 w50  h20, Height:
	Gui, 2:Add, Edit, 		vEditTagX								x86  y222 w50  h20
	Gui, 2:Add, Edit, 		vEditTagY								x86  y252 w50  h20
	Gui, 2:Add, Edit, 		vEditTagW								x86  y282 w50  h20
	Gui, 2:Add, Edit, 		vEditTagH								x86  y312 w50  h20
	Gui, 2:Add, Checkbox, 	vEditTagApplyX							x146 y217 w100 h30, Apply X Position
	Gui, 2:Add, Checkbox, 	vEditTagApplyY							x146 y247 w100 h30, Apply Y Position
	Gui, 2:Add, Checkbox, 	vEditTagApplyW							x146 y277 w100 h30, Apply Width
	Gui, 2:Add, Checkbox, 	vEditTagApplyH							x146 y307 w100 h30, Apply Height

	Gui, 2:Add, GroupBox, 											x16  y357 w340 h80, Explorer Settings
	Gui, 2:Add, Checkbox, 	vEditTagToolBar	    Disabled			x26  y375 w80  h20, ToolBar
	Gui, 2:Add, Checkbox, 	vEditTagStatusBar	Disabled			x96  y375 w70  h20, StatusBar
	Gui, 2:Add, Text, 												x26  y410 w70  h20, View:
	Gui, 2:Add, DropDownList, vEditTagView							x96  y407 w100 h200, %TagViewOptionsList%

	Gui, 2:Add, Button, 	gEditTagOK Default						x16  y447 w80  h30, &OK
	Gui, 2:Add, Button, 	gEditTagCancel							x276 y447 w80  h30, &Cancel

	Gui, 1:+Disabled
	Gui, 2:Show, %EditTagGUIdimensions%, %EditTagGUItitle%
	}

;************************************************************************************************************
; Options Dialog Box Setup:
;************************************************************************************************************
CreateOptionsGUI()
	{
	global
	Gui, 3:Destroy
	Gui, 3:-Maximize -Minimize +ToolWindow +AlwaysOnTop
	Gui, 3:Add, Text, 												x6   y20  w90  h20, AutoApply every:
	Gui, 3:Add, Edit, 	vOptionsApplyInterval						x96  y20  w80  h20, Edit
	Gui, 3:Add, Text, 												x186 y20  w60  h20, Milliseconds
	Gui, 3:Add, Checkbox, vOptionsShowTray							x16  y50  w100 h30, Show TrayIcon

	Gui, 3:Add, GroupBox, 											x6   y90  w240 h220, Hotkeys
	Gui, 3:Add, Text, 												x16  y115 w211 h15, Show Dialog Hotkey:
	Gui, 3:Add, Edit, 	vOptionsMainWinKey							x16  y130 w210 h20, Edit
	Gui, 3:Add, Text, 												x16  y164 w210 h15, On Top Hotkey:
	Gui, 3:Add, Edit, 	vOptionsOnTopKey							x16  y180 w210 h20, Edit
	Gui, 3:Add, Text, 												x16  y213 w209 h16, Not On Top Hotkey:
	Gui, 3:Add, Edit, 	vOptionsNotOnTopKey							x16  y230 w210 h20, Edit
	Gui, 3:Add, Text, 												x16  y262 w209 h16, Hide Window Hotkey:
	Gui, 3:Add, Edit, 	vOptionsHideWindowKey						x16  y279 w210 h20, Edit

	Gui, 3:Add, Button, gOptionsOK	 Default						x16  y318 w80  h30, &OK
	Gui, 3:Add, Button, gOptionsCancel								x158 y318 w80  h30, &Cancel

	Gui, 1:+Disabled
	Gui, 3:Show, %OptionsGUIdimensions%, %OptionsGUItitle%
	}

;************************************************************************************************************
; About Box Setup:
;************************************************************************************************************
CreateAboutGUI()
	{
	global
	Gui, 4:Destroy
	FileRead, ChangeLog, %AppName%_Changelog.txt
	FileRead, HelpText,  %AppName%_Help.txt
	AboutText = %AppName% for Windows`n
	AboutText = %AboutText%Version %Version%`n`n
	AboutText = %AboutText%%ChangeLog%`n`n%HelpText%

	Gui, 4:-Maximize -Minimize +ToolWindow +AlwaysOnTop
	Gui, 4:Font, S8, Courier New
	Gui, 4:Add, Edit, T4 ReadOnly Multi 		x16 y17 w500 h340, %AboutText%
	Gui, 4:Show, xCenter yCenter h370 w531, %AppName% - About
	Send,^{Home}
	Gui, 1:+Disabled
	}

;************************************************************************************************************
; Main program
;************************************************************************************************************
RefreshWinList()
ReadTagFile()
ReadOptions()
CheckHiddenWins()
CreateTrayMenu()

SetTimer, SizeWindows, %ApplyInterval%
SetTimer, CheckHiddenWindows, 10000

; apply tags once the program starts
Gosub, ApplyTags

Return

;************************************************************************************************************
; Hotkey definition:
;************************************************************************************************************
ApplyHotkeys()
	{
	global
	Hotkey, ~RButton, 		 TrayRightClick
	Hotkey, %MainWinKey%, 	 ShowDialog			; Hotkey to show the main GUI
	Hotkey, %OnTopKey%, 	 OnTopKeyLabel		; Make the active window stay on top
	Hotkey, %NotOnTopKey%, 	 NotOnTopKeyLabel	; Make the active window stay not on top
	Hotkey, %HideWindowKey%, HideWindowKeyLabel	; Hide the active window
	}

;************************************************************************************************************
OnTopKeyLabel:
	; Make the active window stay on top
	WinSet, AlwaysOnTop, On, A
Return

;************************************************************************************************************
NotOnTopKeyLabel:
	; Make the active window stay not on top
	WinSet, AlwaysOnTop, Off, A
Return

;************************************************************************************************************
HideWindowKeyLabel:
	; Hide the active window
	WinID := WinExist("A")
	WinGetTitle, Title, ahk_id %WinID%
	MsgBox, 4, %AppName%, Hide %Title%?
	IfMsgBox Yes
		HideWindow(WinID)
Return

;************************************************************************************************************
CheckHiddenWindows:
	CheckHiddenWins()
Return

;************************************************************************************************************
; Handling for left mouse clicks and double clicks on the tray icon
;************************************************************************************************************
ShowDialogClick:   ; either doubleclick on tray icon or show dialog selected from the tray menu
	If TrayRClicked <> Yes
		{
		If TrayClicks =
			{
			SetTimer, TraySingleClick, 500
			TrayClicks = 1
			Return
			}
		}
	SetTimer, TraySingleClick, Off
	;MsgBox, 0, Message, Tray Double Click Detected!
	Gosub, ShowDialog
	TrayClicks =
	TrayRClicked =
Return

TraySingleClick:   ; single click on tray icon detected
	SetTimer, TraySingleClick, Off
	;MsgBox, 0, Message, Tray Single Click Detected!
	Gosub, DisableAutoWinSize
	TrayClicks =
	TrayRClicked =
Return

TrayRightClick:   ; right click on tray icon detected
	TrayRClicked = Yes
	KeyWait, RButton  ; wait for the right mouse button to be released
	TrayRClicked =
Return

;************************************************************************************************************
HiddenWinsMenuClick:
	;msgbox, Unhide %A_ThisMenuItem%
	SetTitleMatchMode, 3
	
	DetectHiddenWindows, On
	IfWinNotExist, %A_ThisMenuItem%
		MsgBox, The window does not exist anymore:`n`n'%A_ThisMenuItem%'
	Else
		WinShow, %A_ThisMenuItem%
	DetectHiddenWindows, Off
	
	WinActivate, %A_ThisMenuItem%
	CheckHiddenWins()
Return

;************************************************************************************************************
DisableAutoWinSize:
	If AutoWinSizeDisabled = 0
		{
		AutoWinSizeDisabled = 1
		Menu, Tray, Check, Disable AutoWinSize
		}
	Else
		{
		AutoWinSizeDisabled = 0
		Menu, Tray, UnCheck, Disable AutoWinSize
		}
	Gosub, SetTrayIcon
Return

;************************************************************************************************************
SetTrayIcon:
	If AutoWinSizeDisabled = 1
		{
		If ExistHiddenWindows = 1
			{
			Menu, Tray, Icon, %A_ScriptFullPath%, %OffHiddenIconNumber%  ; Icon of AutoHotkeySC.bin
			}
		Else
			{
			Menu, Tray, Icon, %A_ScriptFullPath%, %OffIconNumber%  ; Icon of AutoHotkeySC.bin
			}
		}
	Else
		{
		If ExistHiddenWindows = 1
			{
			Menu, Tray, Icon, %A_ScriptFullPath%, %OnHiddenIconNumber%  ; Icon of AutoHotkeySC.bin
			}
		Else
			{
			Menu, Tray, Icon, %A_ScriptFullPath%, %OnIconNumber%  ; Icon of AutoHotkeySC.bin
			}
		}
Return

;************************************************************************************************************
ShowDialog:
	; rebuild the MainGUI to make it appear with the actual icon
	CreateMainGUI()
Return

;************************************************************************************************************
; Main GUI Functions:
;************************************************************************************************************

;************************************************************************************************************
TagWindow:
	Gui, Submit, NoHide
	If WinListGUI =
		{
		MsgBox, 8192, %AppName% - Tag Window, No Window selected from the Active Window list.
		Return
		}

	Comment := WinListComment%WinListGUI%
	
	; check if window title is already tagged
	double = 0
	Loop, %TagCount%
		{
		if TagComment%A_index% = %Comment%
			{
			double = 1
			break
			}
		}
	If double <> 0
		{
		MsgBox, 4096, %AppName% - Tag Window, Window title %Comment% is already tagged.
		Return
		}
	
	; add window title to tag list
	TagCount++
	n = %TagCount%

	;TagList = %TagList%%n% - %Comment% | 
	TagList = %TagList%%Comment% | 

	TagTitle%n%			:= WinListTitle%WinListGUI%
	TagComment%n%		:= WinListComment%WinListGUI%
	TagWinID%n%			:= WinListID%WinListGUI%
	TagWinClass%n%		:= WinListClass%WinListGUI%
	TagWinCount%n%		:= 0
	TagMatchMode%n%		:= WinListMatchMode%WinListGUI%
	TagCenterWin%n%		:= WinListCenterWin%WinListGUI%
	TagApplyOnce%n%		:= WinListApplyOnce%WinListGUI%
	TagIgnoreDialogs%n%	:= WinListIgnoreDialogs%WinListGUI%
	TagX%n%				:= WinListX%WinListGUI%
	TagY%n%				:= WinListY%WinListGUI%
	TagW%n%				:= WinListW%WinListGUI%
	TagH%n%				:= WinListH%WinListGUI%
	TagApplyX%n%		:= WinListApplyX%WinListGUI%
	TagApplyY%n%		:= WinListApplyY%WinListGUI%
	TagApplyW%n%		:= WinListApplyW%WinListGUI%
	TagApplyH%n%		:= WinListApplyH%WinListGUI%
	TagToolBar%n%		:= WinListToolBar%WinListGUI%
	TagStatusBar%n%		:= WinListStatusBar%WinListGUI%
	TagCommand%n%		:= WinListCommand%WinListGUI%
	TagView%n%			:= WinListView%WinListGUI%
	TagAction%n%		:= WinListAction%WinListGUI%

	GuiControl, , TagListGUI, %TagList%
	;msgbox, %TagCount% - %TagList%
Return

;************************************************************************************************************
RemoveTag:
	Gui, Submit, NoHide
	If TagListGUI =
		{
		MsgBox, 8192, %AppName% - Remove Tag, No Window selected from the Tagged Window list.
		Return
		}
	
	CommentDel := TagComment%TagListGUI%
	n = 1
	m = 1
	TagCount--
	TagList = |
	Loop, %TagCount%
		{
		if TagComment%m% = %CommentDel%
			m++

		;msgbox, %a_index% %TitleDel% - n=%n% - m=%m%`n%TagList%
		TagTitle%n%			:= TagTitle%m%
		TagComment%n%		:= TagComment%m%
		TagWinID%n%			:= TagWinID%m%
		TagWinClass%n%		:= TagWinClass%m%
		TagWinCount%n%		:= TagWinCount%m%
		TagMatchMode%n%		:= TagMatchMode%m%
		TagCenterWin%n%		:= TagCenterWin%m%
		TagApplyOnce%n%		:= TagApplyOnce%m%
		TagIgnoreDialogs%n%	:= TagIgnoreDialogs%m%
		TagX%n%				:= TagX%m%
		TagY%n%				:= TagY%m%
		TagW%n%				:= TagW%m%
		TagH%n%				:= TagH%m%
		TagApplyX%n%		:= TagApplyX%m%
		TagApplyY%n%		:= TagApplyY%m%
		TagApplyW%n%		:= TagApplyW%m%
		TagApplyH%n%		:= TagApplyH%m%
		TagToolBar%n%		:= TagToolBar%m%
		TagStatusBar%n%		:= TagStatusBar%m%
		TagCommand%n%		:= TagCommand%m%
		TagView%n%			:= TagView%m%
		TagAction%n%		:= TagAction%m%
	
		Comment := TagComment%n%
		;TagList = %TagList%%n% - %Comment% | 
		TagList = %TagList%%Comment% | 
		n++
		m++
		}
	GuiControl, , TagListGUI, %TagList%
Return

;************************************************************************************************************
ApplyTags:
	Loop, %TagCount%
		TagWinCount%A_index% := 0
Return

;************************************************************************************************************
SaveTags:
	WriteTagFile()
Return

;************************************************************************************************************
RefreshWinList:
	RefreshWinList()
Return

;************************************************************************************************************
ShowInfo:
	Gui, Submit, NoHide
	If WinListGUI =
		{
		MsgBox, 8192, %AppName% - Window Information, No Window selected from the Active Window list.
		}
	Else
		{
		ID    := WinListID%WinListGUI%
		Title := WinListTitle%WinListGUI%
		Class := WinListClass%WinListGUI%
		X     := WinListX%WinListGUI%
		Y     := WinListY%WinListGUI%
		W     := WinListW%WinListGUI%
		H     := WinListH%WinListGUI%
		MsgBox, 8192, %AppName% - Window Information, Window No. %WinListGUI%`nID = %ID%`nTitle = %Title%`nClass = %Class%`nX = %X%`nY = %Y%`nW = %W%`nH = %H%
		}
Return

;************************************************************************************************************
ShowAboutBox:
	CreateAboutGUI()
Return

;************************************************************************************************************
WinListProc:
	If A_GuiControlEvent = DoubleClick  ; the user has doubleclicked on the list box
		Gosub, ShowInfo
Return

;************************************************************************************************************
TagListProc:
	If A_GuiControlEvent = DoubleClick  ; the user has doubleclicked on the list box
		Gosub, EditTag
Return

;************************************************************************************************************
GuiSize:
	If A_EventInfo = 1 ; window has been minimized
	Goto, GuiEscape
Return

;************************************************************************************************************
GuiEscape:
CloseDialog:
	Gui, 1:Destroy
Return

;************************************************************************************************************
GuiClose:
	MsgBox, 4387, %AppName%, Exit %AppName%?
	IfMsgBox, No
		Gosub, CloseDialog
	Else
	IfMsgBox, Yes
		Goto, AppExit
Return

;************************************************************************************************************
AppExit:
	UnhideAllWindows()
	ExitApp
Return

;************************************************************************************************************
; Edit Tag Functions:
;************************************************************************************************************
EditTag:
	Gui, Submit, NoHide
	If TagListGUI =
		{
		MsgBox, 8192, %AppName% - Edit Tag, No Window selected from the Tagged Window list.
		Return
		}

	Title 			:= TagTitle%TagListGUI%
	Comment 		:= TagComment%TagListGUI%
	MatchMode 		:= TagMatchMode%TagListGUI%
	CenterWin 		:= TagCenterWin%TagListGUI%
	ApplyOnce 		:= TagApplyOnce%TagListGUI%
	IgnoreDialogs	:= TagIgnoreDialogs%TagListGUI%
	X 				:= TagX%TagListGUI%
	Y 				:= TagY%TagListGUI%
	W 				:= TagW%TagListGUI%
	H 				:= TagH%TagListGUI%
	ApplyX 			:= TagApplyX%TagListGUI%
	ApplyY 			:= TagApplyY%TagListGUI%
	ApplyW 			:= TagApplyW%TagListGUI%
	ApplyH 			:= TagApplyH%TagListGUI%
	ToolBar 		:= TagToolBar%TagListGUI%
	StatusBar 		:= TagStatusBar%TagListGUI%
	Command 		:= TagCommand%TagListGUI%
	View 	    	:= TagView%TagListGUI%
	Action 			:= TagAction%TagListGUI%

	; the TitleMatchMode listbox needs a new defined list with a selected item:
	If MatchMode = %TagTitleMatchMode1%
		MatchMode = %TitleMatch1Selected%
	Else
	If MatchMode = %TagTitleMatchMode2%
		MatchMode = %TitleMatch2Selected%
	Else
	If MatchMode = %TagTitleMatchMode3%
		MatchMode = %TitleMatch3Selected%
	Else
	If MatchMode = %TagTitleMatchMode4%
		MatchMode = %TitleMatch4Selected%
	Else
		MatchMode = %TitleMatch1Selected% ; default if none of the below applies

	; the View listbox needs a new defined list with a selected item:
	If View = %TagViewOptions1%
		View = %ViewOptions1Selected%
	Else
	If View = %TagViewOptions2%
		View = %ViewOptions2Selected%
	Else
	If View = %TagViewOptions3%
		View = %ViewOptions3Selected%
	Else
	If View = %TagViewOptions4%
		View = %ViewOptions4Selected%
	Else
		View = %ViewOptions4Selected% ; default if none of the below applies

	; the Action listbox needs a new defined list with a selected item:
	If Action = %TagActionOption1%
		Action = %ActionOption1Selected%
	Else
	If Action = %TagActionOption2%
		Action = %ActionOption2Selected%
	Else
	If Action = %TagActionOption3%
		Action = %ActionOption3Selected%
	Else
	If Action = %TagActionOption4%
		Action = %ActionOption4Selected%
	Else
	If Action = %TagActionOption5%
		Action = %ActionOption5Selected%
	Else
	If Action = %TagActionOption6%
		Action = %ActionOption6Selected%
	Else
		Action = %ActionOption6Selected% ; default if none of the below applies

	CreateEditTagGUI()

	GuiControl, 2:, EditTagTitle		, %Title%
	GuiControl, 2:, EditTagComment		, %Comment%
	GuiControl, 2:, EditTagMatchMode	, %MatchMode%
	GuiControl, 2:, EditTagCenterWin	, %CenterWin%
	GuiControl, 2:, EditTagApplyOnce	, %ApplyOnce%
	GuiControl, 2:, EditTagIgnoreDialogs, %IgnoreDialogs%
	GuiControl, 2:, EditTagX			, %X%
	GuiControl, 2:, EditTagY			, %Y%
	GuiControl, 2:, EditTagW			, %W%
	GuiControl, 2:, EditTagH			, %H%
	GuiControl, 2:, EditTagApplyX		, %ApplyX%
	GuiControl, 2:, EditTagApplyY		, %ApplyY%
	GuiControl, 2:, EditTagApplyW		, %ApplyW%
	GuiControl, 2:, EditTagApplyH		, %ApplyH%
	GuiControl, 2:, EditTagToolBar		, %ToolBar%
	GuiControl, 2:, EditTagStatusBar	, %StatusBar%
	GuiControl, 2:, EditTagCommand		, %Command%
	GuiControl, 2:, EditTagView			, %View%
	GuiControl, 2:, EditTagAction		, %Action%
Return

;************************************************************************************************************
EditTagOK:
	Gui, 2:Submit, NoHide

	; Check if the Comment field is not empty
	If EditTagComment =
		{
		MsgBox, 4096, %AppName% - Edit Tag, Please enter a name in the 'Comment' field.
		Return
		}

	; check if window title is already tagged
	double = 0
	Loop, %TagCount%
		{
		If TagComment%A_index% = %EditTagComment%
			If A_index <> %TagListGUI%
				{
				double = 1
				break
				}
		}
	If double <> 0
		{
		MsgBox, 4096, %AppName% - Edit Tag, Entry '%EditTagComment%' already exists in tagged window list.
		Return
		}


	TagTitle%TagListGUI%		:= EditTagTitle
	TagComment%TagListGUI%		:= EditTagComment
	TagMatchMode%TagListGUI%	:= EditTagMatchMode
	TagCenterWin%TagListGUI%	:= EditTagCenterWin
	TagApplyOnce%TagListGUI%	:= EditTagApplyOnce
	TagIgnoreDialogs%TagListGUI%:= EditTagIgnoreDialogs
	TagX%TagListGUI%			:= EditTagX
	TagY%TagListGUI%			:= EditTagY
	TagW%TagListGUI%			:= EditTagW
	TagH%TagListGUI%			:= EditTagH
	TagApplyX%TagListGUI%		:= EditTagApplyX
	TagApplyY%TagListGUI%		:= EditTagApplyY
	TagApplyW%TagListGUI%		:= EditTagApplyW
	TagApplyH%TagListGUI%		:= EditTagApplyH
	TagToolBar%TagListGUI%		:= EditTagToolBar
	TagStatusBar%TagListGUI%	:= EditTagStatusBar
	TagCommand%TagListGUI%		:= EditTagCommand
	TagView%TagListGUI%			:= EditTagView
	TagAction%TagListGUI%		:= EditTagAction
	Gosub, 2GuiClose

	; make TagList actual on the main GUI
	TagList = |
	Loop, %TagCount%
		{
		TempComment := TagComment%a_index%
		;TagList = %TagList%%a_index% - %TempComment%|
		TagList = %TagList%%TempComment%|
		; preselect the selected entry:
		if a_index = %TagListGUI%
			TagList = %TagList%|
		}
	;msgbox, %EditTagComment%`n%TagCount%`n%TagList%
	GuiControl, 1:, TagListGUI, %TagList%
Return

;************************************************************************************************************
2GuiClose:
2GuiEscape:
EditTagCancel:
	Gui, 2:Destroy
	Gui, 1:-Disabled
	SetTitleMatchMode, 3
	WinActivate, %MainGUItitle%
Return

;************************************************************************************************************
; Options Dialog Box:
;************************************************************************************************************
ShowOptionsBox:
	; read options from registry
	ReadOptions()
	
	; Show GUI
	CreateOptionsGUI()
	; put values to GUI
	GuiControl, 3:, OptionsApplyInterval	, %ApplyInterval%
	GuiControl, 3:, OptionsShowTray			, %ShowTrayIcon%
	GuiControl, 3:, OptionsMainWinKey		, %MainWinKey%
	GuiControl, 3:, OptionsOnTopKey			, %OnTopKey%
	GuiControl, 3:, OptionsNotOnTopKey		, %NotOnTopKey%
	GuiControl, 3:, OptionsHideWindowKey	, %HideWindowKey%
Return

;************************************************************************************************************
OptionsOK:
	; get values from GUI
	Gui, 3:Submit, NoHide
	ApplyInterval	:= OptionsApplyInterval
	ShowTrayIcon	:= OptionsShowTray
	MainWinKey		:= OptionsMainWinKey
	OnTopKey		:= OptionsOnTopKey
	NotOnTopKey		:= OptionsNotOnTopKey
	HideWindowKey	:= OptionsHideWindowKey
	
	CheckApplyInterval()
	
	; write values to registry
	WriteOptions()

	; close options GUI
	Gosub, 3GuiClose
	
	; apply setting for tray icon
	If ShowTrayIcon
		Menu, Tray, Icon
	Else
		Menu, Tray, NoIcon
	
	; apply new hotkeys
	ApplyHotkeys()

Return

;************************************************************************************************************
3GuiCancel:
3GuiClose:
3GuiEscape:
3GuiExit:
OptionsCancel:
	Gui, 3:Destroy
	Gui, 1:-Disabled
	SetTitleMatchMode, 3
	WinActivate, %MainGUItitle%
Return

;************************************************************************************************************
; About Box:
;************************************************************************************************************

4GuiCancel:
4GuiClose:
4GuiEscape:
4GuiExit:
	Gui, 4:Destroy
	Gui, 1:-Disabled
	SetTitleMatchMode, 3
	WinActivate, %MainGUItitle%
Return

;************************************************************************************************************
; Timer Functions:
;************************************************************************************************************
; This code sizes/arranges the tagged windows as specified
SizeWindows:
	; check if AutoWinSize is disabled
	If AutoWinSizeDisabled = 1
		Return

;	tiptext =
	Loop, %TagCount%
		{
		m = %a_index%
		TagTitle         := TagTitle%m%
		TagComment       := TagComment%m%
		TagWinID         := TagWinID%m%
		TagWinClass      := TagWinClass%m%
;		TagWinCount      := TagWinCount%m%
		TagMatchMode     := TagMatchMode%m%
		TagCenterWin     := TagCenterWin%m%
		TagApplyOnce     := TagApplyOnce%m%
		TagIgnoreDialogs := TagIgnoreDialogs%m%
		TagX             := TagX%m%
		TagY             := TagY%m%
		TagW             := TagW%m%
		TagH             := TagH%m%
		TagApplyX        := TagApplyX%m%
		TagApplyY        := TagApplyY%m%
		TagApplyW        := TagApplyW%m%
		TagApplyH        := TagApplyH%m%
		TagToolBar       := TagToolBar%m%
		TagStatusBar     := TagStatusBar%m%
		TagCommand       := TagCommand%m%
		TagView          := TagView%m%
		TagAction        := TagAction%m%

		; Apply only once?
		If TagApplyOnce = 1
			{
			; copy array TagWinCount[m] to WinCountIn
			WinCountIn := TagWinCount%m%
			Loop, %WinCountIn%
				WinCountIn%a_index% := TagWinCount%m%_%a_index%
			}
		Else
			WinCountIn := 0
		
		; Center Window?
		If TagCenterWin = 1
			{
			TagX := (A_ScreenWidth / 2) - (TagW / 2)
			TagY := (A_ScreenHeight / 2) - (TagH / 2)
			}
			
		; Apply X, Y, W, H?
		If TagApplyX = 0
			TagX = -1
		If TagApplyY = 0
			TagY = -1
		If TagApplyW = 0
			TagW = -1
		If TagApplyH = 0
			TagH = -1
		
		; Determine TitleMatchMode
		If TagMatchMode = %TagTitleMatchMode1%
			SetTitleMatchMode, 3   ; 3: A window's title must exactly match WinTitle to be a match.
		If TagMatchMode = %TagTitleMatchMode2%
			SetTitleMatchMode, 1   ; 1: A window's title must start with the specified WinTitle to be a match.
		If TagMatchMode = %TagTitleMatchMode3%
			SetTitleMatchMode, 2   ; 2: A window's title can contain WinTitle anywhere inside it to be a match.
		If TagMatchMode = %TagTitleMatchMode4%
			SetTitleMatchMode, RegEx ; RegEx: A window's title can contain Regular Expression to be a match.

		; Call the WinSize function
		PWinSize(TagTitle, TagX, TagY, TagW, TagH)

		; copy WinCountIn back to array TagWinCount[m]
		TagWinCount%m% := WinCountIn
		Loop, %WinCountIn%
			TagWinCount%m%_%a_index% := WinCountIn%a_index%

;		tiptext = %tiptext%`n`n%TagCount% - %TagTitle%`n%TagX%`n%TagY%`n%TagW%`n%TagH%`nWinCountIn=%WinCountIn%`nTagMatchMode=%TagMatchMode%`nTitleMatchMode = %A_TitleMatchMode%
		}
;CoordMode, ToolTip, Screen
;ToolTip, %tiptext%, 0, 200
Return
